/* jshint esversion : 6 */

exports.sort = o => () => require('gulp-sort')(o);


exports.concat = o => () => require('gulp-concat')(o);


exports.strip = o => () => {
    const strip = require('gulp-strip-comments');

    const s = ("object" === typeof o ? o : null);
    return strip(s);
};


exports.wrap = o => () => {

    const wrap = require('gulp-wrap');

    const opt = {
        template: o.template,
        data: o.data || {},
        options: o.options || { parse: false }
    };

    const w = [];
    w.push(opt.template);

    if (Array.isArray(opt.data))
        opt.data.forEach(v => w.push(v));
    else
        w.push(opt.data);

    w.push(opt.options);

    return wrap.apply(wrap, w);
};


exports.sourcemaps = _o => {

    const o = _o.write;

    const sourceMapsOpt = [];
    if ("string" === o)
        sourceMapsOpt.push(o);
    else {
        const opt = {};
        sourceMapsOpt[0] = o.dest;
        for (let k in o) {
            if (k !== 'dest')
                opt[k] = o[k];
        }

        sourceMapsOpt[1] = opt;
    }

    return sourcemaps.apply(sourcemaps, sourceMapsOpt);
};